Package org.spongepowered.asm.mixin.transformer

## Class ActivityStack

- java.lang.Object
- - org.spongepowered.asm.mixin.transformer.ActivityStack

- All Implemented Interfaces:
    `IActivityContext`

      public class ActivityStack
      extends java.lang.Object
      implements IActivityContext

  Tracker for processors which want to express their activity stack on crash in a user-readable way.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `class` | `ActivityStack.Activity` | An activity node in the activity stack (yes it's actually a doubly-linked list).

    - ### Nested classes/interfaces inherited from interface org.spongepowered.asm.mixin.extensibility.IActivityContext

      `IActivityContext.IActivity`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `GLUE_STRING` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ActivityStack()` |
    `ActivityStack​(java.lang.String root)` |
    `ActivityStack​(java.lang.String root, java.lang.String glue)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `IActivityContext.IActivity` | `begin​(java.lang.String description)` | Begin a new activity (push it onto this activity stack)
    `IActivityContext.IActivity` | `begin​(java.lang.String descriptionFormat, java.lang.Object... args)` | Begin a new activity (push it onto this activity stack)
    `void` | `clear()` | Clear the activity stack
    `java.lang.String` | `toString()` |
    `java.lang.String` | `toString​(java.lang.String glue)` | Convert this activity stack to a string representation using the specified glue string

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### GLUE_STRING

          public static final java.lang.String GLUE_STRING

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ActivityStack

          public ActivityStack()

    - #### ActivityStack

          public ActivityStack​(java.lang.String root)

    - #### ActivityStack

          public ActivityStack​(java.lang.String root,
                               java.lang.String glue)

  - ### Method Detail

    - #### clear

          public void clear()

      Clear the activity stack
      Specified by:
        `clear` in interface `IActivityContext`

    - #### begin

          public IActivityContext.IActivity begin​(java.lang.String description)

      Begin a new activity (push it onto this activity stack)
      Specified by:
        `begin` in interface `IActivityContext`
      Parameters:
        `description` - Activity description
      Returns:
        new activity handle

    - #### begin

          public IActivityContext.IActivity begin​(java.lang.String descriptionFormat,
                                                  java.lang.Object... args)

      Begin a new activity (push it onto this activity stack)
      Specified by:
        `begin` in interface `IActivityContext`
      Parameters:
        `descriptionFormat` - Activity description format
        `args` - format args
      Returns:
        new activity handle

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString​(java.lang.String glue)

      Convert this activity stack to a string representation using the specified glue string
      Specified by:
        `toString` in interface `IActivityContext`
      Parameters:
        `glue` - glue string
      Returns:
        string representation of this activity stack